#include <bits/stdc++.h>
using namespace std;

#define LIMIT 1000000007

int n;
vector<int> a;

long long suma = 0;

void f(int i, int j, int k)
{
    if(k == 0)
    {
        for(int it = i; it <= j; ++it)
        {
            suma += a[it];
            if(suma > LIMIT) suma %= LIMIT;
        }
    }
    else
    {
        for(; i < n; ++i)
            for(j = i; j < n; ++j)
                f(i, j, k - 1);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int k;

    cin >> n >> k;
    a.resize(n);

    for(int i = 0; i < n; ++i) cin >> a[i];

    f(0, n - 1, k);

    cout << suma << endl;

    return 0;
}